## Test262 is the official ECMAScript (ECMA-262) conformance suite.

Test262 tests conformance to the continually maintained draft future ECMAScript standard found at http://tc39.github.io/ecma262/ , together with any Stage 3 or later TC39 proposals. It is maintained by Tom Care (@tcare) and Leo Balter (@leobalter) with significant contributions from many in the ECMAScript community.

### Contributing to Test262
> See [CONTRIBUTING.md](./CONTRIBUTING.md)

1. Sign the [Test262 CLA](http://tc39.github.io/test262-cla).
2. Send a pull request. Please make sure you have one commit per pull request. If you have multiple commits, squash them before sending the pull request.

### Running Test262

> See [INTERPRETING.md](./INTERPRETING.md)

There are a number of volunteer-maintained projects that may be used to execute Test262 in various ECMAScript hosts:

- https://github.com/bterlson/test262-harness (platform: Node.js)
- https://github.com/test262-utils/test262-harness-py (platform: Python)
- https://bakkot.github.io/test262-web-runner/ (platform: web)
